



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Jtree（节点的渲染+资源管理器）（2）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Jtree（节点的渲染+资源管理器）（2）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 15:38:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>上一次我们建立一个比较简单的资源管理器，这次我们说一下上面的资源管理器的问题，并且得尽量的贴近windows的资源管理器。</p>
<p>这样一个简单的资源管理树就完成了,下面我们说说它的问题:
<p>① 图片和外观和Windows有差距
<p>这个我们可以通过设置L&amp;F和通过前面写的Renderer那样设置新的图片解决,不是大问题.
<p>② 文件夹里文件多时展开会很慢,会导致界面假死
<p>这个我们可以自己写一个缓加载的TreeNode,让它继承于DefaultMutableTreeNode,在它里面定义加载标示,然后使用SwingWorker或者多线程方式使Tree平稳加载,虽然麻烦,但是也可以解决.
<p>③ Tree点击假死时,用户会以为出现问题,胡乱点击会加载多个事件
<p>这个问题其实是Swing事件机制的问题,其实是没办法解决的,因为总会存在耗时的操作的,不等待是不可能的.但我们可以做更好的用户体验来避免这个问题,这里我想到的解决办法是在Tree上绘制一层GlassPane,屏蔽所有事件,提示用户,等加载完成后,取消GlassPane界面.
<p>④ 只有我的电脑的基本文件,没有网上邻居之类的
<p>这个问题很难解决,涉及到网上邻居就存在网络的问题了,还需要网络连接和扫描,开始我的思路是使用Apache的commons-client做,后来发现有人给出了更好的办法,使用Java的JFileChooser类,Java已经实现了很多我们需要实现的.
<p>⑤ 取得的资源管理树的子目录是乱序的
<p>这个很好解决,使我们的TreeNode实现Comparable接口就可以了.
<p>为了解决这五个问题我们做的改进版:
<p>首先我们解决问题一,看看我们的代码:
<p>节点的图片的样式问题我们可以设置Renderer,又因为这些图片可以在JFileChooser的UI中取得,我们先参照JFileChooser的UI做一个FileView类:
<p>// ***********************
<p>// * FileView operations *
<p>// ***********************
<p><strong>protected</strong><strong>class</strong> BasicFileView <strong>extends</strong> FileView {
<p>复写它的方法:
<p>@Override
<p><strong>public</strong> String getName(File f) {
<p>// Note: Returns display name rather than file name
<p>String fileName = <strong>null</strong>;
<p><strong>if</strong> (f != <strong>null</strong>) {
<p>fileName = chooser.getFileSystemView().getSystemDisplayName(f);
<p>}
<p><strong>return</strong> fileName;
<p>}
<p>这个是显示名字.
<p>@Override
<p><strong>public</strong> String getDescription(File f) {
<p><strong>return</strong> f.getName();
<p>}
<p>这个是描述
<p>@Override
<p><strong>public</strong> String getTypeDescription(File f) {
<p>String type = chooser.getFileSystemView().getSystemTypeDescription(
<p>f);
<p><strong>if</strong> (type == <strong>null</strong>) {
<p><strong>if</strong> (f.isDirectory()) {
<p>type = directoryDescriptionText;
<p>} <strong>else</strong> {
<p>type = fileDescriptionText;
<p>}
<p>}
<p><strong>return</strong> type;
<p>}
<p>这个是文件类别
<p>@Override
<p><strong>public</strong> Icon getIcon(File f) {
<p>这个是图片表示.
<p>这样我们构建这个FileView之后我们需要的图片和名字就都可以取得了.
<p>然后是我们的Renderer了：
<p><strong>private</strong><strong>class</strong> FileSystemTreeRenderer <strong>extends</strong> DefaultTreeCellRenderer {
<p>复写它的方法,设置我们从FileView取得图片和名字：
<p>@Override
<p><strong>public</strong> Component getTreeCellRendererComponent(JTree tree, Object value,<strong> boolean</strong> sel, <strong>boolean</strong> expanded,<strong>boolean</strong> leaf, <strong>int</strong> row,
<p><strong>boolean</strong> hasFocus) {
<p>setText(getFileView(chooser).getName(node.getFile()));
<p>setIcon(getFileView(chooser).getIcon(node.getFile()));
<p>然后设置到树上：
<p>tree.setCellRenderer(<strong>new</strong> FileSystemTreeRenderer());
<p>看看效果:
<p><img referrerpolicy="no-referrer"src="http://www.blogjava.net/images/blogjava_net/zeyuphoenix/x3.jpg">
<p>是不是和Windows的很接近了,设置L&amp;F,如下图:
<p>UIManager.<em>setLookAndFeel</em>(UIManager.<em>getSystemLookAndFeelClassName</em>());
<p><img referrerpolicy="no-referrer"src="http://www.blogjava.net/images/blogjava_net/zeyuphoenix/x4.jpg">
<p>然后解决问题二,我们不能用树的原始节点了,用我们自己构造的,继承于它：
<p><strong>public</strong><strong>abstract</strong><strong>class</strong> LazyMutableTreeNode <strong>extends</strong> DefaultMutableTreeNode {
<p>增加一个属性：
<p>/** is node load. */
<p><strong>private</strong><strong>boolean</strong>loaded = <strong>false</strong>;
<p>提供一个虚方法给子类实现:
<p><strong>protected</strong><strong>abstract</strong><strong>void</strong> loadChildren();
<p>然后是我们的实现:
<p><strong>private</strong><strong>class</strong> FileTreeNode <strong>extends</strong> LazyMutableTreeNode {
<p>复写它的方法,非load不允许加载:
<p>@Override
<p><strong>public</strong><strong>boolean</strong> isLeaf() {
<p><strong>if</strong> (!isLoaded()) {
<p><strong>return</strong><strong>false</strong>;
<p>} <strong>else</strong> {
<p><strong>return</strong><strong>super</strong>.isLeaf();
<p>}
<p>}
<p>还有它的现实名字：
<p>@Override
<p><strong>public</strong> String toString() {
<p><strong>return</strong>chooser.getFileSystemView().getSystemDisplayName(
<p>(File) getUserObject());
<p>}
<p>实现虚方法：
<p>@Override
<p><strong>protected</strong><strong>void</strong> loadChildren() {
<p>FileTreeNode[] nodes = getChildren();
<p><strong>for</strong> (<strong>int</strong> i = 0, c = nodes.length; i &lt; c; i++) {
<p>add(nodes[i]);
<p>}
<p>}
<p>这样问题二就解决了,同时也可以在这里解决我们的问题五,使我们的TreeNode实现Comparable接口:
<p><strong>private</strong><strong>class</strong> FileTreeNode <strong>extends</strong> LazyMutableTreeNode <strong>implements</strong>
<p>Comparable&lt;Object&gt; {
<p>然后实现方法：
<p>@Override
<p><strong>public</strong><strong>int</strong> compareTo(Object o) {
<p><strong>if</strong> (!(o <strong>instanceof</strong> FileTreeNode)) {
<p><strong>return</strong> 1;
<p>}
<p><strong>return</strong> getFile().compareTo(((FileTreeNode) o).getFile());
<p>}
<p>最后在我们使用时：
<p>// sort directories, FileTreeNode implements Comparable
<p>FileTreeNode[] result = (FileTreeNode[]) nodes
<p>.toArray(<strong>new</strong> FileTreeNode[0]);
<p>Arrays.<em>sort</em>(result);
<p>nodes.add(<strong>new</strong> FileTreeNode(result[i]));
<p>这样我们加入的节点文件夹就都是排序的了.
<p>然后我们解决问题四,三比较麻烦留在最后:
<p>构建这个组件时,我们先构建JFileChooser
<p>JFileChooser chooser = <strong>new</strong> JFileChooser();
<p>增加监听：
<p><strong>protected</strong><strong>void</strong> installListeners() {
<p>tree.addTreeSelectionListener(<strong>new</strong> SelectionListener());
<p>chooser.getActionMap().put("refreshTree", <strong>new</strong> UpdateAction());
<p>chooser.getInputMap(JComponent.<em>WHEN_ANCESTOR_OF_FOCUSED_COMPONENT</em>).put(
<p>KeyStroke.<em>getKeyStroke</em>("F5"), "refreshTree");
<p>chooser.addPropertyChangeListener(<strong>new</strong> ChangeListener());
<p>}
<p>在监听中展开树时,使用JFileChooser的方法:
<p>/**
<p>* tree node select change.
<p>*/
<p><strong>private</strong><strong>class</strong> SelectionListener <strong>implements</strong> TreeSelectionListener {
<p>@Override
<p><strong>public</strong><strong>void</strong> valueChanged(TreeSelectionEvent e) {
<p>getApproveSelectionAction()
<p>.setEnabled(tree.getSelectionCount() &gt; 0);
<p>setSelectedFiles();
<p>// the current directory is the one currently selected
<p>TreePath currentDirectoryPath = tree.getSelectionPath();
<p><strong>if</strong> (currentDirectoryPath != <strong>null</strong>) {
<p>File currentDirectory = ((FileTreeNode) currentDirectoryPath
<p>.getLastPathComponent()).getFile();
<p>chooser.setCurrentDirectory(currentDirectory);
<p>}
<p>}
<p>}
<p>这样我们所有的目录结构就不需要自己去循环构建了,使用JFileChooser为我们提供好的就可以了,如下图,网上邻居也有了,问题四完成了：
<p><img referrerpolicy="no-referrer"src="http://www.blogjava.net/images/blogjava_net/zeyuphoenix/x5.jpg">
<p>最后我们来解决问题三,为什么会假死,是因为文件夹多或者网速慢导致的,解决办法当然是多线程,但是多线程在Swing里容易出现线程不安全,因为它不在ADT上,这里我们使用SwingWorker,监听树的展开事件:
<p>tree.addTreeExpansionListener(<strong>new</strong> TreeExpansion());
<p>处理它：
<p><strong>private</strong><strong>class</strong> TreeExpansion <strong>implements</strong> TreeExpansionListener {
<p>@Override
<p><strong>public</strong><strong>void</strong> treeCollapsed(TreeExpansionEvent event) {
<p>}
<p>@Override
<p><strong>public</strong><strong>void</strong> treeExpanded(TreeExpansionEvent event) {
<p>// ensure children gets expanded later
<p><strong>if</strong> (event.getPath() != <strong>null</strong>) {
<p>Object lastElement = event.getPath().getLastPathComponent();
<p><strong>if</strong> (lastElement <strong>instanceof</strong> FileTreeNode &amp;&amp; useNodeQueue)
<p><strong>if</strong> (((FileTreeNode) lastElement).isLoaded()) {
<p>慢主要是在这里的处理,我们把它放在SwingWorker里面:
<p><strong>new</strong> WorkerQueue(node, tree, glassPane).execute();
<p>然后看这个类:
<p><strong>private</strong><strong>static</strong><strong>final</strong><strong>class</strong> WorkerQueue <strong>extends</strong>
<p>SwingWorker&lt;Void, FileTreeNode&gt; {
<p>复写它的方法,处理我们的TreeNode添加事件:
<p>@Override
<p><strong>protected</strong> Void doInBackground() <strong>throws</strong> Exception {
<p>glassPanel.setVisible(<strong>true</strong>);
<p><strong>for</strong> (Enumeration&lt;?&gt; e = node.children(); e.hasMoreElements();) {
<p>publish((FileTreeNode) e.nextElement());
<p>}
<p><strong>return</strong><strong>null</strong>;
<p>}
<p>@Override
<p><strong>protected</strong><strong>void</strong> process(List&lt;FileTreeNode&gt; chunks) {
<p><strong>for</strong> (FileTreeNode fileTreeNode : chunks) {
<p>fileTreeNode.getChildCount();
<p>}
<p>}
<p>@Override
<p><strong>protected</strong><strong>void</strong> done() {
<p>glassPanel.setVisible(<strong>false</strong>);
<p>tree.repaint();
<p>}
<p>然后是处理我们在展开节点时屏蔽所有的鼠标点击并给以用户提示,这里我们自己绘制一个Component,把它设置为GlassPane,屏蔽所有事件:
<p>/**
<p>*/
<p><strong>public</strong><strong>class</strong> GlassPane <strong>extends</strong> JComponent {
<p>屏蔽所有事件,只能获得焦点：
<p>// blocks all user input
<p>addMouseListener(<strong>new</strong> MouseAdapter() {
<p>});
<p>addMouseMotionListener(<strong>new</strong> MouseMotionAdapter() {
<p>});
<p>addKeyListener(<strong>new</strong> KeyAdapter() {
<p>});
<p>setFocusTraversalKeysEnabled(<strong>false</strong>);
<p>addComponentListener(<strong>new</strong> ComponentAdapter() {
<p><strong>public</strong><strong>void</strong> componentShown(ComponentEvent evt) {
<p>requestFocusInWindow();
<p>}
<p>});
<p>然后是绘制：
<p>@Override
<p><strong>protected</strong><strong>void</strong> paintComponent(Graphics g) {
<p>先绘制整体背景：
<p>// gets the current clipping area
<p>Rectangle clip = g.getClipBounds();
<p>// sets a 65% translucent composite
<p>AlphaComposite alpha = AlphaComposite.<em>SrcOver</em>.derive(0.65f);
<p>Composite composite = g2.getComposite();
<p>g2.setComposite(alpha);
<p>// fills the background
<p>g2.setColor(getBackground());
<p>g2.fillRect(clip.x, clip.y, clip.width, clip.height);
<p>g2.setComposite(composite);
<p>然后绘制一张提示图片,本来想绘制一个滚动的等待图标<img referrerpolicy="no-referrer"src="http://www.blogjava.net/images/blogjava_net/zeyuphoenix/x6.jpg">的,实在是没心情写了,随便Google了张图片放上去了.
<p><strong>if</strong> (image == <strong>null</strong>) {
<p><strong>try</strong> {
<p>image = ImageIO.<em>read</em>(getClass().getResource("wait2.jpg"));
<p>} <strong>catch</strong> (IOException ex) {
<p>ex.printStackTrace();
<p>}
<p>}
<p>g.drawImage(image, getWidth() / 2 - 40, getHeight() / 2
<p>- 80, 120, 120, <strong>null</strong>);
<p>通过设置画面的GlassPane就可以了
<p>Component glassPane = <strong>new</strong> GlassPane();
<p>frame.getRootPane().setGlassPane(glassPane);
<p>------没有完成，后面还有。留个尾巴</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pg3kz9.html">selenium3&period;0&period;1调用firefox</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldo509.html">python装饰器入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5jo2q.html">spring 获取 bean</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv63eo8.html">JSTL（JSP Standard Tag Library）读书笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q742wgq.html">codeforces  374A Inna and Pink Pony  解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v7v5o8.html">转：Beautiful Soup</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd14jm8.html">Jquery ajax请求导出Excel表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5e2v8.html">js--eval函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdwld78.html">HttpWatch网络抓包工具的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrk448.html">使用JQUERY操作Radio</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1okdmq.html">redmine 安装（Centos 6&period;5 x64）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pg7n48.html">UEP-时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljre719.html">值得注意的CSS属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyw4jxq.html">aop（权限控制）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyokzd9.html">flask sqlchemy 多对多的自引用关系定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14nlxq.html">HashMap深度解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jnpnjq.html">Linux查看所有用户和组信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o56w18.html">Sql server中如何将表A和表B的数据合并（乘积方式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960x1w39.html">（转）ScriptManager&period;RegisterStartupScript方法和Page&period;ClientScript&period;RegisterStartupScript&lpar;&rpar; 方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kop0v5q.html">【GDKOI 2016】地图 map 类插头DP</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8okevnx9.html">玩转docker</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd253r8.html">LeetCode 6&period; ZigZag Conversion  Question</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm4wek9.html">&lbrack;Angular 2&rsqb; Transclusion in Angular 2</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mr2ekq.html">iOS 音频开发经验汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn0yyrq.html">Android摇一摇振动效果Demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mr0xjq.html">speex的基本编码和解码流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1vroe9.html">WEB服务健康状态检测</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z3d5z9.html">SplitButton&lpar; 分割按钮&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdxm1d8.html">DataGrid简单数据绑定实例2</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzkg09.html">纯js滑动脚本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
